class
	P_CMP_SI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_cmp_si (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v_digit: INTEGER_32): INTEGER_32
		local
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_u_digit: NATURAL_32
			l_absv_digit: NATURAL_32
			l_return: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			l_absv_digit := a_v_digit.to_natural_32
			l_vsize := (0).to_integer_32
			if a_v_digit > 0 then
				l_vsize := (1).to_integer_32
			elseif a_v_digit < 0 then
				l_vsize := (-1).to_integer_32
				l_absv_digit := (-l_absv_digit.to_integer_32).to_natural_32
			end
			if l_usize /= l_vsize then
				Result := (l_usize - l_vsize).to_integer_32
				l_return := True
			end
			if not l_return and then (l_usize = 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_u_digit := a_u.item.mp_d[0]
				if l_u_digit = l_absv_digit then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_u_digit > l_absv_digit then
					Result := l_usize.to_integer_32
				else
					Result := (-l_usize).to_integer_32
				end
			end
		end

end
