class
	P_FIB2_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_fib2_ui (a_fn, a_fnsub1: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_fp: CE_POINTER [NATURAL_32]
			l_f1p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
		do
			l_size := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
			if (builtin_expect ((l_size > (a_fn.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				(create {P_REALLOC_STATIC}).gmpz_realloc (a_fn, l_size).do_nothing
			end
			if (builtin_expect ((l_size > (a_fnsub1.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				(create {P_REALLOC_STATIC}).gmpz_realloc (a_fnsub1, l_size).do_nothing
			end
			l_fp := a_fn.item.mp_d
			l_f1p := a_fnsub1.item.mp_d
			l_size := (create {P_GMP_IMPL_STATIC}).gmpn_fib2_ui (l_fp, l_f1p, a_n)
			a_fn.item.mp_size := (l_size - (a_n = {NATURAL_32} 0).to_integer).to_integer_32
			a_fnsub1.item.mp_size := (l_size - (l_f1p[(l_size - 1)] = {NATURAL_32} 0).to_integer).to_integer_32
		end

end
