class
	P_ISET_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_init_set (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_size := l_usize
			else
				l_size := -l_usize
			end
			if l_size > 1 then
				a_w.item.mp_alloc := l_size.to_integer_32
			else
				a_w.item.mp_alloc := 1
			end
			a_w.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([(a_w.item.mp_alloc * 4).to_natural_32]))))
			l_wp := a_w.item.mp_d
			l_up := a_u.item.mp_d
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			a_w.item.mp_size := l_usize.to_integer_32
		end

end
