class
	P_SET_SI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_set_si (a_dest: CE_POINTER [PD_MPZ_STRUCT]; a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: NATURAL_32
		do
			if a_val >= 0 then
				l_tmp := a_val.to_natural_32
			else
				l_tmp := (-((a_val + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32).to_natural_32
			end
			l_vl := l_tmp
			a_dest.item.mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			if a_val >= 0 then
				a_dest.item.mp_size := l_size.to_integer_32
			else
				a_dest.item.mp_size := (-l_size).to_integer_32
			end
		end

end
