class
	P_CMP_UI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_cmp_ui (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v_digit: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_ul: NATURAL_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_up := a_u.item.mp_d
			l_un := (a_u.item.mp_size).to_integer_32
			if l_un = 0 then
				Result := (-(a_v_digit /= {NATURAL_32} 0).to_integer).to_integer
				l_return := True
			end
			if not l_return and then (l_un = 1) then
				l_ul := l_up[0]
				if l_ul > a_v_digit then
					Result := 1
					l_return := True
				end
				if not l_return and then (l_ul < a_v_digit) then
					Result := (-1)
					l_return := True
				end
				if not l_return then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_un > 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
			end
		end

end
