class
	P_GET_D_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_get_d (a_z: CE_POINTER [PD_MPZ_STRUCT]): REAL_64
		local
			l_size: INTEGER_32
			l_tmp_0: INTEGER_32
			l_return: BOOLEAN
		do
			l_size := (a_z.item.mp_size).to_integer_32
			if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_tmp_0 := l_size
				else
					l_tmp_0 := -l_size
				end
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_get_d (a_z.item.mp_d, l_tmp_0, l_size, 0))
			end
		end

end
