class
	P_POWM_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	reduce (a_tp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32)
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_2: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp_2 := (l_aaf.new ((((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp_2 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_2);
			(create {P_GMP_STATIC}).gmpn_tdiv_qr (l_qp, a_tp, 0, a_ap, a_an, a_mp, a_mn)
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
		end

	gmpz_powm_ui (a_r, a_b: CE_POINTER [PD_MPZ_STRUCT]; a_el: NATURAL_32; a_m: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_xp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_xn: INTEGER_32
			l_tn: INTEGER_32
			l_mn: INTEGER_32
			l_bn: INTEGER_32
			l_m_zero_cnt: INTEGER_32
			l_c: INTEGER_32
			l_e: NATURAL_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_new_mp: CE_POINTER [NATURAL_32]
			l_tmp_2: CE_POINTER [ANY]
			l_new_bp: CE_POINTER [NATURAL_32]
			l_tmp_7: CE_POINTER [ANY]
			l_tmp_13: CE_POINTER [ANY]
			l_tmp_18: CE_POINTER [ANY]
			l_tmp_23: CE_POINTER [ANY]
			l_cy: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mp := a_m.item.mp_d
					if a_m.item.mp_size >= 0 then
						l_mn := (a_m.item.mp_size).to_integer_32
					else
						l_mn := (-a_m.item.mp_size).to_integer_32
					end
					if l_mn = 0 then
						(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
					end
					if a_el = {NATURAL_32} 0 then
						if l_mn = 1 then
							if l_mp[0] = {NATURAL_32} 1 then
								a_r.item.mp_size := 0
							else
								a_r.item.mp_size := 1
							end
						else
							a_r.item.mp_size := 1
						end
						a_r.item.mp_d[0] := (1).to_natural_32
						l_return := True
					end
					if not l_return then
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_m_zero_cnt := builtin_clzl (l_mp[(l_mn - 1)])
							l_break := True
						end
						l_break := False
						l_m_zero_cnt := l_m_zero_cnt
						if l_m_zero_cnt /= 0 then
							if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_2 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_2 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_mp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_2);
							(create {P_GMP_STATIC}).gmpn_lshift (l_new_mp, l_mp, l_mn, l_m_zero_cnt.to_natural_32).do_nothing
							l_mp := l_new_mp
						end
						if a_b.item.mp_size >= 0 then
							l_bn := (a_b.item.mp_size).to_integer_32
						else
							l_bn := (-a_b.item.mp_size).to_integer_32
						end
						l_bp := a_b.item.mp_d
						if l_bn > l_mn then
							if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_7 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_bp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7)
							reduce (l_new_bp, l_bp, l_bn, l_mp, l_mn)
							l_bp := l_new_bp
							l_bn := l_mn
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_bn > 0))
								loop
									l_break := False
									if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_bn := l_bn - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						if l_bn = 0 then
							a_r.item.mp_size := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if (builtin_expect (((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_13 := (l_aaf.new (((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_13 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_13)
						if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_18 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_18 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_18)
						if (builtin_expect (((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_23 := (l_aaf.new (((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_23 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_23)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_bp, l_bn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_xn := l_bn
						l_e := a_el
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_c := builtin_clzl (l_e)
							l_break := True
						end
						l_break := False
						l_e := (((l_e).bit_shift_left (l_c))).bit_shift_left (1)
						l_c := 31 - l_c
						if l_c = 0 then
							if l_xn = l_mn then
								if ((create {P_GMP_STATIC}).gmpn_cmp (l_xp, l_mp, l_mn)) >= 0 then
									(create {P_GMP_STATIC}).gmpn_sub_n (l_xp, l_xp, l_mp, l_mn).do_nothing
								end
							end
							l_pos := -1 + 3 -- goto finishup
						end
				when 2 then
						from
						until
							not (not (l_return) and then (l_c /= 0))
						loop
							(create {P_GMP_STATIC}).gmpn_sqr (l_tp, l_xp, l_xn)
							l_tn := 2 * l_xn
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							if l_tn < l_mn then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_tp, l_tn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_xn := l_tn
							else
								(create {P_GMP_STATIC}).gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_tn, l_mp, l_mn)
								l_xn := l_mn
							end
							if l_e.to_integer_32 < 0 then
								(create {P_GMP_STATIC}).gmpn_mul (l_tp, l_xp, l_xn, l_bp, l_bn).do_nothing
								l_tn := l_xn + l_bn
								l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
								if l_tn < l_mn then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_tp, l_tn)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									l_xn := l_tn
								else
									(create {P_GMP_STATIC}).gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_tn, l_mp, l_mn)
									l_xn := l_mn
								end
							end
							l_e := (l_e).bit_shift_left ((1))
							l_c := l_c - 1
						end
				when 3 then -- finishup:
						if l_m_zero_cnt /= 0 then
							l_cy := (create {P_GMP_STATIC}).gmpn_lshift (l_tp, l_xp, l_xn, l_m_zero_cnt.to_natural_32)
							l_tp[l_xn] := l_cy
							l_xn := l_xn + (l_cy /= {NATURAL_32} 0).to_integer
							if l_xn < l_mn then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_tp, l_xn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							else
								(create {P_GMP_STATIC}).gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_xn, l_mp, l_mn)
								l_xn := l_mn
							end
							(create {P_GMP_STATIC}).gmpn_rshift (l_xp, l_xp, l_xn, l_m_zero_cnt.to_natural_32).do_nothing
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_xn > 0))
							loop
								l_break := False
								if l_xp[(l_xn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_xn := l_xn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((a_el).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							if a_b.item.mp_size < 0 then
								if l_xn /= 0 then
									l_mp := a_m.item.mp_d;
									(create {P_GMP_STATIC}).gmpn_sub (l_xp, l_mp, l_mn, l_xp, l_xn).do_nothing
									l_xn := l_mn
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											not (not (l_break) and then (l_xn > 0))
										loop
											l_break := False
											if l_xp[(l_xn - 1)] /= {NATURAL_32} 0 then
												l_break := True
											end
											if not (l_return or l_break) then
												l_xn := l_xn - 1
											end
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
							end
						end
						if (builtin_expect ((l_xn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							(create {P_REALLOC_STATIC}).gmpz_realloc (a_r, l_xn).do_nothing
						end
						a_r.item.mp_size := l_xn.to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_r.item.mp_d, l_xp, l_xn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
