class
	P_RANDOM_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_random (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_size: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			if a_size >= 0 then
				l_tmp := a_size
			else
				l_tmp := -a_size
			end
			if not ((create {P_GMP_IMPL_STATIC}).gmp_rands_initialized).to_boolean then
				(create {P_GMP_IMPL_STATIC}).gmp_rands_initialized := (1).to_integer_8;
				(create {P_GMP_IMPL_STATIC}).gmp_randinit_mt_noseed (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (((create {P_GMP_IMPL_STATIC}).gmp_rands)))
			end
			(create {P_URANDOMB_STATIC}).gmpz_urandomb (a_x, create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (((create {P_GMP_IMPL_STATIC}).gmp_rands)), (l_tmp * 32).to_natural_32)
			if a_size < 0 then
				a_x.item.mp_size := -a_x.item.mp_size
			end
		end

end
