class
	P_REALLOC2_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gmpz_realloc2 (a_m: CE_POINTER [PD_MPZ_STRUCT]; a_bits: NATURAL_32)
		local
			l_bits: NATURAL_32
			l_new_alloc: INTEGER_32
			l_tmp_1: INTEGER_32
		do
			l_bits := a_bits
			l_bits := l_bits - (l_bits /= {NATURAL_32} 0).to_integer.to_natural_32
			l_new_alloc := ({NATURAL_32} 1 + l_bits // {NATURAL_32} 32).to_integer_32
			a_m.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_reallocate_func.pointer_item ([create {CE_VOID_POINTER}.make_cast (a_m.item.mp_d), (a_m.item.mp_alloc).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32, (l_new_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
			a_m.item.mp_alloc := l_new_alloc.to_integer_32
			if a_m.item.mp_size >= 0 then
				l_tmp_1 := a_m.item.mp_size
			else
				l_tmp_1 := -a_m.item.mp_size
			end
			if l_tmp_1.to_integer_32 > l_new_alloc then
				a_m.item.mp_size := 0
			end
		end

end
