class
	P_SWAP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_swap (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ualloc: INTEGER_32
			l_valloc: INTEGER_32
		do
			l_ualloc := (a_u.item.mp_alloc).to_integer_32
			l_valloc := (a_v.item.mp_alloc).to_integer_32
			a_v.item.mp_alloc := l_ualloc.to_integer_32
			a_u.item.mp_alloc := l_valloc.to_integer_32
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			a_v.item.mp_size := l_usize.to_integer_32
			a_u.item.mp_size := l_vsize.to_integer_32
			l_up := a_u.item.mp_d
			l_vp := a_v.item.mp_d
			a_v.item.mp_d := l_up
			a_u.item.mp_d := l_vp
		end

end
